
package _Buffer;
@ISA = qw( _Observee );

####################################
# Class Variables

@BUFFERS; # These are our buffers

####################################
# Class Methods

sub new {
	#_DebugLog("Fund new\n");
	my($class) = shift;
	my($self) = {};
	bless $self, $class;
	push @BUFFERS,$self;
	$self->Initialize;
	return $self;
}

####################################
# Instance Methods

sub Initialize {
	my($self) = shift;

	$self->SUPER::Initialize;
	return $self;
}

sub Delete {
	my($self) = shift;
	my($i) = _Locate($self);
	splice(@BUFFERS,$i,1);
	$self->NotifyObservers("Deleted");
	if($#BUFFERS<0){
		#&main::DebugLog("_Buffer Delete Creating a default buffer\n");
		my($newbuf) = new Fundamental;
		my($newview) = new View ("full",$newbuf);
		$newview->BecomeEditView;
	} else {
		$i = 0 if($i>$#BUFFERS);
		#&main::DebugLog("_Buffer Delete Switching to buffer $i\n");
		View->AssignToEditView($BUFFERS[$i]);
	}
}

sub DeleteAndExitIfLast {
	my($self) = shift;
	my($i) = _Locate($self);
        splice(@BUFFERS,$i,1);
        $self->NotifyObservers("Deleted");
	&main::ExitOnReturn if($#BUFFERS < 0);
}

sub SelectNextBuffer {
	my($self) = shift;

	#&main::DebugLog("SelectNextBuffer\n");
	my($i) = _Locate($self);
	#&main::DebugLog("   I am buffer $i\n");
	$i = -1 if($i == $#BUFFERS);
	$i++;
	#&main::DebugLog("   Switching to buffer $i\n");
	View->AssignToEditView($BUFFERS[$i]);
}

sub SelectPrevBuffer {
        my($class) = shift;
        my($i) = _Locate($self);
        $i = $#BUFFERS + 1 if($i == 0);
        $i--;
        View->AssignToEditView($BUFFERS[$i]);
}

sub _Locate {
	my($self) = shift;
        my($i);

        for($i=0,$i<=$#BUFFERS,){
                if($BUFFERS[$i] == $self){
                        last;
                }
		$i++;
        }               
	return $i;
}

sub DispatchKey {
	my($self) = shift;
	my($key,$map) = (@_);

	#Dispatch the key
	my($method)=
		#if the key has a function assigned, use it
		$$map{$key}
		#otherwise just ignore it
		|| sub {}; # NoOp
	$self->$method($key);
}

1;

